#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "php.h"
#include <php5/main/php_network.h>
#include <php5/ext/standard/file.h>
#include <ancillary.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
 
#define PHP_ANCILLARY_VERSION "1.0"
#define PHP_ANCILLARY_EXTNAME "ancillary"
 
extern zend_module_entry ancillary_module_entry;
#define phpext_ancillary_ptr &ancillary_module_entry
 
// declaration of a custom mop_function()
PHP_FUNCTION(ancillary_getstream);
 
// list of custom PHP functions provided by this extension
// set {NULL, NULL, NULL} as the last record to mark the end of list
static function_entry ancillary_getstream[] = {
    PHP_FE(ancillary_getstream, NULL)
    {NULL, NULL, NULL}
};
 
// the following code creates an entry for the module and registers it with Zend.
zend_module_entry ancillary_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
    STANDARD_MODULE_HEADER,
#endif
    PHP_ANCILLARY_EXTNAME,
    ancillary_getstream,
    NULL, // name of the MINIT function or NULL if not applicable
    NULL, // name of the MSHUTDOWN function or NULL if not applicable
    NULL, // name of the RINIT function or NULL if not applicable
    NULL, // name of the RSHUTDOWN function or NULL if not applicable
    NULL, // name of the MINFO function or NULL if not applicable
#if ZEND_MODULE_API_NO >= 20010901
    PHP_ANCILLARY_VERSION,
#endif
    STANDARD_MODULE_PROPERTIES
};
 
ZEND_GET_MODULE(ancillary)

#define CTRL_BUFF_MAX_SZ (8*1024)
 
// starting from a unix socket receive a socket from an external process
PHP_FUNCTION(ancillary_getstream)
{
    zval *zstream;
    php_stream *stream;
    int fd_in, fd_out[2], retrecv, curpos = 0;
    char *headers;
    zval *zheaders;
    php_netstream_data_t *sock;

    if ((headers = calloc(CTRL_BUFF_MAX_SZ, 1)) == NULL) {
        return;
    }

    if (FAILURE == zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rz", &zstream, &zheaders)) {
        free(headers);
        return;
    }
    
    php_stream_from_zval(stream, &zstream);

    if (php_stream_cast(stream, PHP_STREAM_AS_FD, (void*)&fd_in, REPORT_ERRORS) == FAILURE) {
        free(headers);
        RETURN_FALSE;
    }

    if(ancil_recv_fds(fd_in, fd_out, 2) == 0) {
        free(headers);
        RETURN_FALSE;
    }

    {
        char bf[2048];

        sprintf(bf, "zero: [%d]    uno: [%d]\n", fd_out[0], fd_out[1]);
        write(1, bf, strlen(bf));
    }
    while(1) {
        write(1, "LOOP\n", 5);
        retrecv = recv(fd_out[1], &(headers[curpos]), CTRL_BUFF_MAX_SZ - curpos - 1, 0);
        if (retrecv < 0) {
            free(headers);
            RETURN_FALSE;
        }
        else if (retrecv == 0) {
            break;
        }
        else {
            char bf[1024];
            curpos += retrecv;
            sprintf(bf, "CURPOS: %d\n", curpos);
            write(1, bf, strlen(bf));
            if (curpos == CTRL_BUFF_MAX_SZ - 1) {
                free(headers);
                RETURN_FALSE;
            }
        }
    }
    shutdown(fd_out[1], SHUT_RDWR);

    ZVAL_STRING(zheaders, headers, 1);
    free(headers);

    {
        int fh;

        if ((fh = open("/tmp/out_php-anc.txt", O_WRONLY | O_CREAT | O_APPEND)) > -1) {
            write(fh, headers, curpos);
            close(fh);
        }
    }

    sock = pemalloc(sizeof(php_netstream_data_t), 0);
    memset(sock, 0, sizeof(php_netstream_data_t));

    sock->is_blocked = 1;
    sock->timeout.tv_sec = FG(default_socket_timeout);
    sock->timeout.tv_usec = 0;

    /* we don't know the socket until we have determined if we are binding or
     * connecting */
    sock->socket = fd_out[0];

    stream = php_stream_alloc_rel(&php_stream_socket_ops, sock, NULL, "r+");

    if (stream == NULL)	{
        pefree(sock, 0);
        return NULL;
    }
    php_stream_to_zval(stream, return_value);
}
 
